



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ 2212: [Poi2011]Tree Rotations( 线段树 )</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ 2212: [Poi2011]Tree Rotations( 线段树 )</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 08:52:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/723896/201508/132215418648460.png" /></p>
<p>线段树的合并..对于一个点x, 我们只需考虑是否需要交换左右儿子, 递归处理左右儿子.</p>
<div>
<div>
<pre class="prettyprint linenums"> #include&lt;bits/stdc++.h&gt;

 using namespace std;

 #define M(l, r) (((l) + (r)) &gt;&gt; 1)

 typedef long long ll;

 const int maxn = ;

 int N, V[maxn], lc[maxn], rc[maxn], n = ;

 struct Node *null, *pt;<br />
 struct Node {<br />
     Node *l, *r;<br />
     int cnt;<br />
     Node() : cnt() {<br />
         l = r = null;<br />
     }<br />
     inline void update() {<br />
         cnt = l-&gt;cnt + r-&gt;cnt;<br />
     }<br />
     void* operator new(size_t) {<br />
         return pt++;<br />
     }<br />
 } pool[maxn * ], *root[maxn];

 void init() {<br />
     pt = pool;<br />
     null = new(Node);<br />
     null-&gt;l = null-&gt;r = null;<br />
 }

 int v;<br />
 void build(Node* t, int l, int r) {<br />
     t-&gt;cnt = ;<br />
     if(r &gt; l) {<br />
         int m = M(l, r);<br />
         v &lt;= m ? build(t-&gt;l = new(Node), l, m) : build(t-&gt;r = new(Node), m + , r);<br />
     }<br />
 }

 ll cnt0, cnt1, ans = ;

 Node* merge(Node* L, Node* R) {<br />
     if(L == null) return R;<br />
     if(R == null) return L;<br />
     cnt0 += ll(L-&gt;r-&gt;cnt) * R-&gt;l-&gt;cnt;<br />
     cnt1 += ll(L-&gt;l-&gt;cnt) * R-&gt;r-&gt;cnt;<br />
     L-&gt;l = merge(L-&gt;l, R-&gt;l);<br />
     L-&gt;r = merge(L-&gt;r, R-&gt;r);<br />
     L-&gt;update();<br />
     return L;<br />
 }

 void read(int x) {<br />
     scanf("%d",  V + x);<br />
     if(!V[x]) {<br />
         read(lc[x] = n++); read(rc[x] = n++);<br />
     }<br />
 }

 void work(int x) {<br />
     if(!~x) return;<br />
     work(lc[x]); work(rc[x]);<br />
     if(!V[x]) {<br />
         cnt0 = cnt1 = ;<br />
         if(!~lc[x])<br />
             root[x] = root[rc[x]];<br />
         else if(!~rc[x])<br />
             root[x] = root[lc[x]];<br />
         else<br />
             root[x] = merge(root[lc[x]], root[rc[x]]);<br />
         ans += min(cnt0, cnt1);<br />
     }<br />
 }

 int main() {

     init();<br />
     memset(lc, -, sizeof lc); memset(rc, -, sizeof rc);<br />
     scanf("%d", &amp;N);<br />
     n = ; read(n++);

     for(int i = ; i &lt; n; i++) if(V[i]) {<br />
         v = V[i];<br />
         build(root[i] = new(Node), , N);<br />
     }<br />
     work();<br />
     cout &lt;&lt; ans &lt;&lt; "\n";

     return ;<br />
 }</pre>
</div>
</div>
<h2>2212: [Poi2011]Tree Rotations</h2>
<p>Time Limit:&nbsp;20 Sec&nbsp;&nbsp;Memory Limit:&nbsp;259 MB<br />Submit:&nbsp;548&nbsp;&nbsp;Solved:&nbsp;195<br />[<a href="http://www.lydsy.com/JudgeOnline/submitpage.php?id=2212" rel="external nofollow noreferrer">Submit</a>][<a href="http://www.lydsy.com/JudgeOnline/problemstatus.php?id=2212" rel="external nofollow noreferrer">Status</a>][<a href="http://www.lydsy.com/JudgeOnline/bbs.php?id=2212" rel="external nofollow noreferrer">Discuss</a>]</p>
<h2>Description</h2>
<div>
<p>Byteasar the gardener is growing a rare tree called Rotatus Informatikus. It has some interesting features: The tree consists of straight branches, bifurcations and leaves. The trunk stemming from the ground is also a branch. Each branch ends with either a bifurcation or a leaf on its top end. Exactly two branches fork out from a bifurcation at the end of a branch - the left branch and the right branch. Each leaf of the tree is labelled with an integer from the range . The labels of leaves are unique. With some gardening work, a so called rotation can be performed on any bifurcation, swapping the left and right branches that fork out of it. The corona of the tree is the sequence of integers obtained by reading the leaves' labels from left to right. Byteasar is from the old town of Byteburg and, like all true Byteburgers, praises neatness and order. He wonders how neat can his tree become thanks to appropriate rotations. The neatness of a tree is measured by the number of inversions in its corona, i.e. the number of pairs（I,j）, (1&lt; = I &lt; j &lt; = N ) such that(Ai&gt;Aj) in the corona(A1,A2,A3&hellip;An).&nbsp;<img referrerpolicy="no-referrer"src="http://www.lydsy.com/JudgeOnline/images/2212.jpg" />&nbsp;The original tree (on the left) with corona(3,1,2) has two inversions. A single rotation gives a tree (on the right) with corona(1,3,2), which has only one inversion. Each of these two trees has 5 branches. Write a program that determines the minimum number of inversions in the corona of Byteasar's tree that can be obtained by rotations.</p>
<p>现在有一棵二叉树，所有非叶子节点都有两个孩子。在每个叶子节点上有一个权值(有n个叶子节点，满足这些权值为1..n的一个排列)。可以任意交换每个非叶子节点的左右孩子。<br />要求进行一系列交换，使得最终所有叶子节点的权值按照遍历序写出来，逆序对个数最少。</p>
</div>
<h2>Input</h2>
<div>
<p>In the first line of the standard input there is a single integer (2&lt; = N &lt; = 200000) that denotes the number of leaves in Byteasar's tree. Next, the description of the tree follows. The tree is defined recursively: if there is a leaf labelled with ()(1&lt;=P&lt;=N) at the end of the trunk (i.e., the branch from which the tree stems), then the tree's description consists of a single line containing a single integer , if there is a bifurcation at the end of the trunk, then the tree's description consists of three parts: the first line holds a single number , then the description of the left subtree follows (as if the left branch forking out of the bifurcation was its trunk), and finally the description of the right subtree follows (as if the right branch forking out of the bifurcation was its trunk).</p>
<p>第一行n<br />下面每行，一个数x<br />如果x==0，表示这个节点非叶子节点，递归地向下读入其左孩子和右孩子的信息，<br />如果x!=0，表示这个节点是叶子节点，权值为x</p>
<p>1&lt;=n&lt;=200000</p>
</div>
<h2>Output</h2>
<div>
<p>In the first and only line of the standard output a single integer is to be printed: the minimum number of inversions in the corona of the input tree that can be obtained by a sequence of rotations.</p>
<p>一行，最少逆序对个数</p>
</div>
<h2>Sample Input</h2>
<div>3<br />
0<br />
0<br />
3<br />
1<br />
2
</div>
<h2>Sample Output</h2>
<div>1</div>
<h2>HINT</h2>
<div>&nbsp;</div>
<h2>Source</h2>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e5r5x8.html">JavaScriptSerializer使用条件</a>
		</li>
						<li><a href="https://www.batexi.com/a/390xpx49.html">XML学习摘要</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xooyn9.html">Java数据库操作大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwzlx9.html">MyEclipse中文注释乱码解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x6l7g9.html">Java实战之03Spring-01Spring概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjjwzj8.html">&lbrack;LeetCode116&rsqb;Path Sum</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5ykr8.html">POJ 2724 Purifying Machine（最大独立集）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjv70q.html">&commat;Scheduled&lpar;cron &equals; &amp;quot&semi;0 0 &ast; &ast; &ast; &quest;&amp;quot&semi;&rpar;实现定时任务</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpm4er9.html">Anton and School</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj7n438.html">程序员如何面试才能拿到offer</a>
		</li>
						<li><a href="https://www.batexi.com/a/9505nyz8.html">&period;net core  mysql  ef</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25vmnlq.html">Linux Shell完成Qt程序的自动部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2z56q.html">Android动态设置纯色图标的颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wm7rwq.html">Jmeter（四十二）Jmeter工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv7yng8.html">KADEMLIA算法学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvezr6o9.html">MySQL数据库----流程控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vjdl2q.html">lamdba 性能测试 大数据内存查找</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlrddr9.html">用两条命令看出你买的H3C光模块是否是正品</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1v2vjzq.html">黑马程序员&lowbar;java基础笔记&lpar;01&rpar;&period;&period;&period;java的环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4wp45q.html">转  WEB前端性能分析--工具篇</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnjm13k8.html">飘逸的python - 一个最简单的服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge1ep48.html">hdu 3966 Aragorn&amp;amp&semi;&num;39&semi;s Story&lpar;树链剖分&plus;树状数组&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jdj1v8.html">c 计算Fibonacci数列：1，1，2，3，5，8，13&hellip;&hellip;这题也是很经典。</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlje1219.html">String to Integer &lpar;atoi&rpar; - 复杂的测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/8memdj6q.html">Map接口的学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1w2r2q.html">Oracle Hint用法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eye0ox9.html">&lbrack;置顶&rsqb; P2P之我见，关于打洞的学问-------开篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp05kj9.html">通过原生js的ajax或jquery的ajax获取服务器的时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjk03z8.html">QT学习 之 QwtPlot（数学绘图）</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rwwz8.html">vs2010 调试中监视变量</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
